#include <stdio.h>
#include "defines.h"
#include "nasm.h"
#include OSBIND
#include "debug.h"
#include "labels.h"
#include "object.h"
#include "code.h"
#include "lib.h"
#include "ldebug.h"



#if BIGENDIAN
void  flip_libstructs( gindex, findex, globals, files)
g_table huge   *globals;
f_table huge   *files;
{
   register lword       i;
   register word huge   *q;
   {
      register g_table huge   *p;

      for( p = globals, i = gindex; i--; p++)
      {
         POINTER_CHECK( p);
         dswap( &p->index);
      }
   }
   {
      register f_table huge   *p;

      for( p = files, i = findex; i--; p++)
      {
         q = (word *) &p->seek;
         POINTER_CHECK( q);
         lswap( q); q += 2;   /* seek     */
         lswap( q); q += 2;   /* bytes    */
         dswap( q); q++;      /* time     */
         dswap( q);           /* date     */
      }
   }
}
#endif

