# if you have UNIX you probably don't need this kludge

#AFLAGS=-NOLIST
ARC= zoo # lharc # arc
# update
UPDATE=aunhI # u -s -w$(TMPDIR)  # u
# update with subdirectories
DIRUP=aunhI # u -r2 -p -s -w$(TMPDIR) # uz
# update without compression
STOREUP=aunfPI: # u -r- -u -w$(TMPDIR) # us
# extract overwrite with subdirs
EXTROVDIR= x//O #  x -r -x -p -w$(TMPDIR) -m # eoz
AEXT=zoo # lzh # zoo 

GSOURCES=*.h *.c *.tlk *.s *.y make*.* make*
GLIBSRCS=lib/src/*
GLIBINCS=lib/*.?65 header/* demo/*
GSUPPORT=support/*
GBINARYS=doc/README doc/INSTALL doc/COPYRITE *.ttp
GARCHIVE=$(ARCDIR)/doc.$(AEXT) $(ARCDIR)/libinc.$(AEXT) $(ARCDIR)/support.$(AEXT)
GDOCS   =doc/*

help:
	echo "specify: backup manifests clean unixclean archives or mailable"


manifests:
	-	ls $(GSOURCES) > MANIFEST.SRC
	-	ls $(GLIBINCS) > lib/MANIFEST
	-	ls $(GLIBSRCS) > lib/src/MANIFEST
	-	ls $(GDOCS)    > doc/MANIFEST
	-	ls $(GSUPPORT) > support/MANIFEST
	-	ls $(GBINARYS) $(GARCHIVE) > MANIFEST.BIN

archives:	srcarcs binarcs

srcarcs:	clean manifests
	find MANIFEST.SRC $(GSOURCES) -print | $(ARC) $(UPDATE)  $(ARCDIR)/nsrc     
	find $(GLIBSRCS) -print | $(ARC) $(DIRUP)   $(ARCDIR)/libsrc   
	find $(ARCDIR)/libsrc.$(AEXT)-print | $(ARC) $(STOREUP) $(ARCDIR)/nsrc     
	find $(GLIBINCS) -print | $(ARC) $(DIRUP)   $(ARCDIR)/libinc   
	find $(GDOCS) -print 	| $(ARC) $(DIRUP)   $(ARCDIR)/doc      
	find $(GSUPPORT) -print | $(ARC) $(DIRUP)   $(ARCDIR)/support  

binarcs:
	find $(GBINARYS) MANIFEST.BIN -print | $(ARC) $(UPDATE)  $(ARCDIR)/nbin     
	find $(GARCHIVE) -print | $(ARC) $(STOREUP) $(ARCDIR)/nbin     

mailable:   archives
	uuencode -500 $(ARCDIR)/nbin.$(AEXT)
	uuencode -500 $(ARCDIR)/nsrc.$(AEXT)

clean:
	-	rm doc/*.dup
	-	rm header/*.dup
	-	rm demo/*.o65
	-	rm demo/*.com
	-	rm demo/*.dis
	-	rm demo/*.dup
	-	rm *.dup
	-	rm $(GLIBSRCS)/*.dup
	-	rm $(GLIBSRCS)/*.o65

unixclean:
	-	rm *.o *.i *~

