#ifndef _NASM_
# define _NASM_ 1
# ifndef _STRUCTS_
#  include "structs.h"
# endif
label
               *enter_elabel(),
               *enter_flabel(),
               *enter_llabel(),
               *find_label(),
               *lab_alloc(),
               *llab_alloc();


macro
               *find_macro();


expr
               *copyexpr(),
               *ival_pl(),
               *lval_pl(),
               *op_pl(),
               *sexp_alloc();


lexpr
               *lex_alloc(),
               *lex_get(),
               *lex_pl(),
               *slex_ch();

ref
               *ref_alloc();


imm
               *imm_alloc();

fix
               *fix_alloc();

seg
               *seg_alloc();


void
               align(),
               aload(),
               build_rseg(),
               build_seg(),
               callfoo(),
               check_dseg(),
               check_fseg(),
               clean_labels(),
               code_reloc(),
               complete(),
               cure_patch(),
               do_calc(),
               do_patch(),
               do_load(),
               do_local(),
               do_macro(),
               downcase(),
               def_label(),
               delete(),
               dpop(),
               dropfloat(),
               dropbytes(),
               dropdbytes(),
               dropsbytes(),
               dropwords(),
               dummy(),
               dump_imm(),
               dump_buffer(),
               dump_open(),
               dump_reloc(),
               dump_stack(),
               endif_treat(),
               else_treat(),
               enter_pclabel(),
               entrefer(),
               err_undefs(),
               err_wrongdefs(),
               exp_link(),
               exp_makbuf(),
               expr_tryfree(),
               extract(),
               file_lib(),
               finalshit(),
               finalstats(),
               find_undef(),
               fix_include(),
               fix_lup(),
               fix_up(),
               fixheader(),
               fix_makbuf(),
               fliplinks(),
               flipstructs(),
               generate(),
               get_minmax(),
               h_print(),
               if_treat(),
               imm_link(),
               imm_makbuf(),
               inc_line(),
               include(),
               junk_suckin(),
               kill_buffer(),
               lerr_imms(),
               list(),
               llab_free(),
               load_macro(),
               lsyntax(),
               mark(),
               nexit(),
               next_buffer(),
               oload(),
               page0decl(),
               pluserrors(),
               print_char(),
               print_secret(),
               print2_secret(),
               pro_init(),
               pro_exit(),
               prtname(),
               real_setorg(),
               recalc(),
               ref_link(),
               rel_makbuf(),
               refer(),
               rept_macro(),
               reserve(),
               save_patch(),
               schtatz(),
               seg_link(),
               seg_makbuf(),
               setorg(),
               show_all(),
               show_jmp(),
               show_values(),
               stats(),
               sym_lib(),
               sym_link(),
               sym_makbuf(),
               sym2_link(),
               takt(),
               the_10seek(),
               undefine(),
               upcase(),
               version0(),
               vpopchk(),
               vpushchk(),
               wrapup(),
               write_results(),
               xload(),
               yy_txt2val(),
               yyerror();

float
               *make_float();

lword
               x_write(),
               x_read(),
               calc_hash(),
               exp_size(),
               fix_size(),
               imm_size(),
               rel_size(),
               seg_size(),
               sym_size();


int
               ab_ascin(),
               check_name(),
               check_double(),
               directive_suckin(),
               file_suckin(),
               float_suckin(),
               get_itoken(),
               get_etoken(),
               hex_suckin(),
               ident2_suckin(),
               ident_suckin(),
               int_suckin(),
               is_def(),
               is_ref(),
               ismarked(),
               label_suckin(),
               lerr_undefs(),
               lex_cnt(),
               lexer(),
               lload(),
               load(),
               macro_suckin(),
               nilexer(),
               option_suckin(),
               para_suckin(),
               push(),
               string_suckin(),
               yylex(),
               yyparse();


char
               *cnv(),
               *get_filename(),
               *make_string(),
               *str_alloc();
               

char               
               pop(),
               look();


byte
               input(),
               uinput();
               
void           nwarning(),
               nmessage(),
               nswarning(),
               nerror(),
               nierror(),
               nterror(),
               nberror(),
               nferror(),
               ngerror(),
               ngferror(),
               nserror(),
               npanic(),
               nexit(),
               nharhar(),
               ENTER(), 
               MESS(), 
               SMESS(), 
               IMESS(), 
               LEAVE(),
               ALEAVE(),
               SETBACK(), 
               SAVESTATE(),
               ab_gchr1(),
               ab_tstnum(),
               ab_getchar(),
               ab_tstchar(),
               ab_norm(),
               ab_zfr0(),
               ab_zxly(),
               ab_nibsh0();
#endif

