#if VERSION
# define INTEGRITY_CHECK()
# define POINTER_CHECK( p)
# define LABEL_CHECK( p)
# define ADD_WATCH( p, size, name)
# define DEL_WATCH( p)
#else
# define INTEGRITY_CHECK()         do_check()
# define POINTER_CHECK( p)         bad_pointer( p)
# define LABEL_CHECK( p)           check_label( p)
# define ADD_WATCH( p, size, name) add_watch( p, size, name)  
# define DEL_WATCH( p)             del_watch( p)  
#endif
